#ifndef __PPSI_EXPORTS_H
#define __PPSI_EXPORTS_H

#include <stdio.h>
#include <stdlib.h>

#define PPSIEXP_COMMAND_TRACKING				1

/* Return values */
#define PPSIEXP_RET_OK						0
#define PPSIEXP_RET_ERROR_CMD					1
#define PPSIEXP_RET_ERROR_VAL					2
#define PPSIEXP_RET_ERROR_INSTANCE				3

/* Commands for ppsiexp_update_param_cmd */
#define PPSIEXP_PARAM_PRIORITY1_CMD				1
#define PPSIEXP_PARAM_PRIORITY2_CMD				2

/* Commands for ppsiexp_update_param64_cmd */
#define PPSIEXP_PARAM64_ALPHA_CMD				1

/* Commands for ppsiexp_update_param_str_cmd */
#define PPSIEXP_PARAM_STR_DIAG_CMD				1

/* Commands for ppsiexp_update_param_instance_cmd */
#define PPSIEXP_PARAM_INST_DELAY_REQ_INT_CMD			1
#define PPSIEXP_PARAM_INST_SYNC_INT_CMD				2
#define PPSIEXP_PARAM_INST_EXTENSION_CMD 			3
#define PPSIEXP_PARAM_INST_PROFILE_CMD 				4
#define PPSIEXP_PARAM_INST_AUTONEG_CMD 				5

/* Commands for ppsiexp_update_param_str_instance_cmd */
#define PPSIEXP_PARAM_INST_STR_DIAG_CMD 			1

/* Values for PPSIEXP_PARAM_INST_EXTENSION_CMD */
#define PPSIEXP_PARAM_EXTENSION_NONE				PPSI_EXT_NONE
#define PPSIEXP_PARAM_EXTENSION_WR				PPSI_EXT_WR
#define PPSIEXP_PARAM_EXTENSION_L1SYNC				PPSI_EXT_L1S

/* Values for PPSIEXP_PARAM_INST_PROFILE_CMD */
#define PPSIEXP_PARAM_PROFILE_PTP				PPSI_PROFILE_PTP
#define PPSIEXP_PARAM_PROFILE_HA_WR				PPSI_PROFILE_HA_WR
#define PPSIEXP_PARAM_PROFILE_CUSTOM				PPSI_PROFILE_CUSTOM

#define PPSIEXP_COMMAND_TRACKING_DISABLE			WRH_TRACKING_DISABLE
#define PPSIEXP_COMMAND_TRACKING_ENABLE				WRH_TRACKING_ENABLE
#define PPSIEXP_COMMAND_TRACKING_TOGGLE				WRH_TRACKING_TOGGLE


#define PPSI_INSTANCE_USE_PORT					0x80000000

/* Export structures, shared by server and client for argument matching */
#ifdef PPSI_EXPORT_STRUCTURES

struct minipc_pd __rpcdef_cmd = {
	.name = "cmd",
	.retval = MINIPC_ARG_ENCODE(MINIPC_ATYPE_INT, int),
	.args = {
		MINIPC_ARG_ENCODE(MINIPC_ATYPE_INT, int),
		MINIPC_ARG_ENCODE(MINIPC_ATYPE_INT, int),
		MINIPC_ARG_END,
	},
};

struct minipc_pd ppsiexp_update_param_cmd = {
	.name = "params",
	.retval = MINIPC_ARG_ENCODE(MINIPC_ATYPE_INT, int),
	.args = {
		MINIPC_ARG_ENCODE(MINIPC_ATYPE_INT, int), /* Command/parameter */
		MINIPC_ARG_ENCODE(MINIPC_ATYPE_INT, int), /* New value */
		MINIPC_ARG_END,
	},
};

struct minipc_pd ppsiexp_update_param64_cmd = {
	.name = "params64",
	.retval = MINIPC_ARG_ENCODE(MINIPC_ATYPE_INT, int),
	.args = {
		MINIPC_ARG_ENCODE(MINIPC_ATYPE_INT, int), /* Command/parameter */
		MINIPC_ARG_ENCODE(MINIPC_ATYPE_INT64, int64_t), /* New value */
		MINIPC_ARG_END,
	},
};

struct minipc_pd ppsiexp_update_param_str_cmd = {
	.name = "params str",
	.retval = MINIPC_ARG_ENCODE(MINIPC_ATYPE_INT, int),
	.args = {
		MINIPC_ARG_ENCODE(MINIPC_ATYPE_INT, int), /* Command/parameter */
		MINIPC_ARG_ENCODE(MINIPC_ATYPE_STRING, char *), /* New value */
		MINIPC_ARG_END,
	},
};

struct minipc_pd ppsiexp_update_param_instance_cmd = {
	.name = "instance param",
	.retval = MINIPC_ARG_ENCODE(MINIPC_ATYPE_INT, int),
	.args = {
		MINIPC_ARG_ENCODE(MINIPC_ATYPE_INT, int), /* Command/parameter */
		MINIPC_ARG_ENCODE(MINIPC_ATYPE_INT, int), /* Instance */
		MINIPC_ARG_ENCODE(MINIPC_ATYPE_INT, int), /* New value */
		MINIPC_ARG_END,
	},
};

struct minipc_pd ppsiexp_update_param_instance_str_cmd = {
	.name = "inst params str",
	.retval = MINIPC_ARG_ENCODE(MINIPC_ATYPE_INT, int),
	.args = {
		MINIPC_ARG_ENCODE(MINIPC_ATYPE_INT, int), /* Command/parameter */
		MINIPC_ARG_ENCODE(MINIPC_ATYPE_INT, int), /* Instance */
		MINIPC_ARG_ENCODE(MINIPC_ATYPE_STRING, char *), /* New value */
		MINIPC_ARG_END,
	},
};

#endif /* PPSI_EXPORT_STRUCTURES */

#endif /* __PPSI_EXPORTS_H */
