/*
 * Copyright (C) 2023 CERN (www.cern.ch)
 * Author: Adam Wujek
 *
 * Released according to the GNU LGPL, version 2.1 or any later version.
 */

#ifndef USERSPACE_PPSI_INCLUDE_PPSI_BMC_CMP_H_
#define USERSPACE_PPSI_INCLUDE_PPSI_BMC_CMP_H_

#define PPSI_BMC_CMP_REASON_UNKNOWN		0
#define PPSI_BMC_CMP_REASON_NOT_QUALIFIED	1
#define PPSI_BMC_CMP_REASON_PRIO1		2
#define PPSI_BMC_CMP_REASON_PRIO2		3
#define PPSI_BMC_CMP_REASON_CLOCKCLASS		4
#define PPSI_BMC_CMP_REASON_CLOCKACCURACY	5
#define PPSI_BMC_CMP_REASON_LOGVARIANCE		6
#define PPSI_BMC_CMP_REASON_CLOCKID		7
#define PPSI_BMC_CMP_REASON_PORTNUMBER		8
#define PPSI_BMC_CMP_REASON_STEPSREMOVED	9
#define PPSI_BMC_CMP_REASON_SOURCEPORTID	10
#define PPSI_BMC_CMP_REASON_RECEIVEPORTID	11

extern char *bmc_cmp_reason[];

int bmc_pidcmp_reason(struct PortIdentity *a, struct PortIdentity *b, int *reason);
int bmc_idcmp_reason(struct ClockIdentity *a, struct ClockIdentity *b, int *reason);

int bmc_dataset_cmp(struct pp_instance *ppi,
		    struct pp_frgn_master *a,
		    struct pp_frgn_master *b);
int bmc_dataset_cmp_reason(struct pp_instance *ppi,
			   struct pp_frgn_master *a,
			   struct pp_frgn_master *b,
			   int *reason);
int bmc_topology_cmp(struct pp_instance *ppi,
		     struct pp_frgn_master *a,
		     struct pp_frgn_master *b);
int bmc_topology_cmp_reason(struct pp_instance *ppi,
			    struct pp_frgn_master *a,
			    struct pp_frgn_master *b,
			    int *reason);
int bmc_gm_cmp(struct pp_instance *ppi,
	       struct pp_frgn_master *a,
	       struct pp_frgn_master *b);
int bmc_gm_cmp_reason(struct pp_instance *ppi,
		      struct pp_frgn_master *a,
		      struct pp_frgn_master *b,
		      int *reason);
int is_qualified(struct pp_instance *ppi, struct pp_frgn_master *foreignMaster);

#endif /* USERSPACE_PPSI_INCLUDE_PPSI_BMC_CMP_H_ */
