/*
 * Copyright (C) 2023 CERN (www.cern.ch)
 * Author: Adam Wujek for CERN
 *
 * Released according to the GNU LGPL, version 2.1 or any later version.
 */

#ifndef __EXT_AUTONEG_API_H__
#define __EXT_AUTONEG_API_H__

/* All data used as extension ppsi l1sync must be put here */
struct ext_autoneg_data {
	int counter_announce_wr;
	int counter_announce_no_wr;
};

struct pp_instance;

int ext_autoneg_l1e_handle_announce(struct pp_instance * ppi, void *buf, int len);
int ext_autoneg_check_signaling_for_l1sync(struct pp_instance * ppi, void *buf, int len);

int ext_autoneg_handle_l1sync(struct pp_instance * ppi, void *buf, int len);
int ext_autoneg_check_signaling_for_slave_present(struct pp_instance * ppi, void *buf, int len);
int ext_autoneg_wr_handle_announce(struct pp_instance * ppi, void *buf, int len);

#endif /* __EXT_AUTONEG_API_H__ */
