/*
 * Copyright (C) 2013 CERN (www.cern.ch)
 * Author: Alessandro Rubini
 *
 * Released according to the GNU LGPL, version 2.1 or any later version.
 */

typedef struct  {
	const char *name; /* if name==NULL then the counter is considered as free */
	int ctrlFlag;
} timeOutConfig_t;


static const timeOutConfig_t timeOutConfigs[PP_TO_COUNT]= {
	{
		.name="REQUEST",
		.ctrlFlag= TMO_CF_INSTANCE_DEPENDENT | TMO_CF_ALLOW_COMMON_SET,
	},
	{
		.name="SYNC_SEND",
		.ctrlFlag= TMO_CF_INSTANCE_DEPENDENT | TMO_CF_ALLOW_COMMON_SET,
	},
	{
		.name="BMC",
	},
	{
		.name="ANN_RECEIPT",
		.ctrlFlag= TMO_CF_INSTANCE_DEPENDENT | TMO_CF_ALLOW_COMMON_SET,
	},
	{
		.name="ANN_SEND",
		.ctrlFlag= TMO_CF_INSTANCE_DEPENDENT | TMO_CF_ALLOW_COMMON_SET,
	},
	{
		.name="QUAL",
		.ctrlFlag= TMO_CF_INSTANCE_DEPENDENT | TMO_CF_ALLOW_COMMON_SET,
	},
	{
		.name="PROT_STATE",
		.ctrlFlag= TMO_CF_INSTANCE_DEPENDENT,
	},
	{
		.name="IN_STATE",
		.ctrlFlag= TMO_CF_INSTANCE_DEPENDENT,
	},
	{
		.name="GM_BY_BMCA",
		.ctrlFlag= 0,
	},
	{
		.name="L1E_TX_SYNC",
		.ctrlFlag = TMO_CF_INSTANCE_DEPENDENT
	},
	{
		.name="L1E_RX_SYNC",
		.ctrlFlag = TMO_CF_INSTANCE_DEPENDENT
	},
	{
		.name="WR_EXT",
		.ctrlFlag = TMO_CF_INSTANCE_DEPENDENT
	},
#if CONFIG_ARCH_IS_WRS == 1
	{
		.name="SEND_PORT_INDEX",
		.ctrlFlag = 0,
	},
	{
		.name="GM_REFRESH",
		.ctrlFlag = 0,
	},
#endif
};

